/*
  configures the device for Linux (OSS) Music drivers.
  Copyright (C) 1998  Martin Vogt

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */



#ifndef __AUDIODEVICELINUX_H
#define __AUDIODEVICELINUX_H

extern "C" {
#include <pthread.h>
#include <sys/ioctl.h> 
#include <sys/soundcard.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
	   }

#include <devices/audioDevice.h>


#ifdef SOUND_VERSION
#define IOCTL(a,b,c)            ioctl(a,b,&c)
#else
#define IOCTL(a,b,c)            (c = ioctl(a,b,c) )
#endif


#define SSLIMIT      18
#define RAWDATASIZE    (2*2*32*SSLIMIT)

#define MONO   0
#define STEREO 1

/*
  Class should be abstract..
*/

// define the max buffer siez in bytes
// It seems that this size is sufficient for most /dev/dsp player
#define _MAX_BUFFER_SIZE       8192



class AudioDeviceLinux : public AudioDevice {

  int fd;
  YafAudioInfo* currentInfo;
  char* device;
  OutputDevice* owner;
  int lBlocked;
  int buffersize;
  int lNeedInit;
  int lWithReopen;


 public:
  AudioDeviceLinux(char* device,int blocked);
  ~AudioDeviceLinux();

  char* getNodeName();
  
  int openDevice();
  int closeDevice();
  
  
  int getPreferredBufferSize();
  
  
  // Special functions for device

  void setDeviceConfig(DeviceConfig* buf);
  int needInit(DeviceConfig* buf);
  
  int rawWrite(char* buf,int len);

};

#endif


