//
//  Kmpg
// 
//  Copyright (C) 1997 Bjarni Ivarsson
//  email: Bjarni.Ivarsson@swipnet.se
// 
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

#ifndef INFOLINE_H
#define INFOLINE_H

#include <qwidget.h>
#include <qpixmap.h>
#include <qtimer.h>
#include <qfontmet.h>

//#include "led.h"
#include "playlistmgr.h"
#include "fileinfo.h"

class InfoLine : public QWidget
{
      Q_OBJECT
   public:
      InfoLine( QWidget*, PlaylistMgr* , int);
      ~InfoLine();
   signals:
      void sigSizeChanged();
   public slots:
      void doClear();
      void doUpdate( int, QString );
      void setInfo( Fileinfo& );
      void scrollTimeout();
   private:
      void resizeInfoLine();
      int scrollPos, scrollInc;
      int _width, _height, _textposy, _lineheight;
      QTimer *scrollTimer;
      QPixmap pm_back;
      QPixmap pm_filename;
      QPixmap pm_stereo, pm_copyright, pm_copy;

   protected:
      PlaylistMgr *_mgr;
      QWidget *_panel;
};
#endif
